﻿using HarmonyLib;
using System;
using System.Reflection;
using UnityEngine;

public class SharkSpy : Mod
{
    private Harmony instance;

    public void Start()
    {
        Debug.Log("SharkSpy has been loaded!");
        instance = new Harmony("TeigRolle.SharkSpy");
        this.instance.PatchAll(Assembly.GetExecutingAssembly());
    }

    public void OnModUnload()
    {
        this.instance.UnpatchAll("TeigRolle.SharkSpy");
        Debug.Log("SharkSpy has been unloaded!");
        Destroy(gameObject);
    }
}

[HarmonyPatch(typeof(Helper), "ClosestPlayerInWaterToPoint", MethodType.Normal)]
[HarmonyPatch(new Type[] { typeof(Vector3), typeof(float), typeof(bool) })]
class Patch_Shark_ClosestPlayerInWaterToPoint
{
    public static bool Prefix(Shark __instance, ref Network_Player __result, Vector3 point, float maxDistanceFromPoint, bool includeDeadPlayers = true)
    {
        Type type = typeof(Helper);
        FieldInfo info = type.GetField("network", BindingFlags.NonPublic | BindingFlags.Static);
        Semih_Network net = (Semih_Network)info.GetValue(null);


        if (net == null || net.remoteUsers == null)
        {
            __result = null;
        }
        Network_Player result = null;
        float num = float.MaxValue;

        foreach (Network_Player network_Player in net.remoteUsers.Values)
        {

            bool eqFlag = false;

            foreach (Equipment equipment in (Equipment[])Traverse.Create(network_Player.PlayerEquipment).Field("equipment").GetValue())
            {
                if (equipment.Equipped && equipment.equipableItem == ItemManager.GetItemByName("Head_Shark"))
                {
                    eqFlag = true;
                }
            }

            if (!(network_Player == null) && (includeDeadPlayers || !network_Player.PlayerScript.IsDead) && Helper.IsValidWaterTarget(network_Player) && !eqFlag)
            {
                float num2 = Vector3.Distance(point, network_Player.transform.position);
                if (num2 <= num && num2 <= maxDistanceFromPoint)
                {
                    result = network_Player;
                    num = num2;
                }
            }
        }
        __result = result;
        return false;
    }
}